#line 1 "C:/Users/Konstantin/Desktop/ATmega644P_AD7656_ExtInt/source/ATmega644P_AD7656_ExtInt.c"
typedef unsigned short uint8_t;
typedef unsigned int uint16_t;
typedef signed int int16_t;
sbit Chip_Select at PORTB4_bit;
sbit Chip_Select_Direction at DDB4_bit;

int16_t write2bytes(uint16_t command) {
uint8_t higherByte, lowerByte;
int16_t result;

 higherByte = (uint8_t)((command & 0xFF00) >> 8);
 lowerByte = (uint8_t)(command & 0x00FF);

 SPDR = higherByte;
 while(!(SPSR & (1<<SPIF)));
 result = SPDR & 0xFF;
 result <<= 8;
 SPDR = lowerByte;
 while(!(SPSR & (1<<SPIF)));
 result |= SPDR;

 return result;
}

uint8_t SPI_init(void) {

 DDB6_bit = 0;
 DDB5_bit = 1;
 Chip_Select = 1;
 Chip_Select_Direction = 1;
 SPI1_Init_Advanced(_SPI_MASTER, _SPI_FCY_DIV128, _SPI_CLK_LO_LEADING);

 return 0;
}

uint8_t sendThroughUART(char *text_) {

 UART1_Write_Text(text_);
 UART1_Write(13);
 UART1_Write(10);

 return 0;
}

uint8_t startSampling(void) {

 PORTA.F0 = 0;


 Delay_us(1);
 PORTA.F0 = 1;



 return 0;
}

int16_t VBs[] = {0, 0, 0, 0, 0, 0};
uint8_t readADC(void) {
uint8_t j;

 Chip_Select = 0;
 PORTA.F4 = 0;
 for (j = 0; j < 6; j++)
 VBs[j] = write2bytes(0x0000);
 PORTA.F4 = 1;
 Chip_Select = 1;

 return 0;
}

uint8_t processData(void) {
uint16_t result = 0;
uint8_t j;
char buffer[16];

 for (j = 0; j < 6; j++) {
 result = VBs[j];
 sprintf(buffer, "%d", result);
 sendThroughUART(buffer);
 }

 UART1_Write_Text("END OF CONVERSION"); UART1_Write(13); UART1_Write(10);

 return 0;
}

void interrupt_ISR () org IVT_ADDR_INT0 {

 SREG_I_bit = 0;
 readADC();
 SREG_I_bit = 1;

 return;
}

uint8_t init(void) {

 DDA0_bit = 1;
 DDA1_bit = 1;
 DDA2_bit = 1;

 DDA4_bit = 1;

 SPI_init();
 UART1_Init(57600);
 Delay_ms(100);
 PORTA.F0 = 1;



 EICRA = 0b00000010;
 EIMSK = 0b00000001;
 SREG_I_bit = 1;

 return 0;
}

void main() {

 init();

 while (1) {
 startSampling();
 processData();
 Delay_ms(100);
 }

 return;
}
